var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as React from "react";
import { componentStateEngine } from "./stateEngine";
import { makeField } from "./Field";
import { validFn, isInvalidResult, isCovalidateResult } from "./validation/index";
var Form = /** @class */ (function (_super) {
    __extends(Form, _super);
    /**
     * When a Form is instantiated, generate a state engine with initial empty
     * state - this will be filled in by Fields, and create the Field component
     * that will be injected.
     */
    function Form(props) {
        var _this = _super.call(this, props) || this;
        /**
         * Generates the Field that will be passed in InjectedFormProps
         */
        _this.makeField = function (resetField) {
            if (resetField === void 0) { resetField = true; }
            _this.Field = makeField({
                onChange: _this.handleFieldChange,
                getInitialValue: _this.getInitialValue
            }, _this.stateEngine, resetField);
        };
        /**
         * Reset everything to initial values
         * State will be fleshed out by Field children when they are recreated
         */
        _this.reset = function () {
            _this.stateEngine
                .set({
                fields: {},
                submitted: false
            })
                .then(function () { return _this.makeField(); })
                .then(function () { return _this.forceUpdate(); });
        };
        /**
         * Allows Fields to get to their initial state
         */
        _this.getInitialValue = function (name) {
            return _this.props.initialValues[name] || "";
        };
        /**
         * Is every field passing validation
         */
        _this.allValid = function (validationResult) {
            return (_this.stateEngine.select(function (s) { return s.meta.validation.valid; }) &&
                Object.values(validationResult).every(function (r) { return (r.meta.validation ? r.meta.validation.valid : true); }));
        };
        /**
         * If there is a validator for field with name of {name}
         * then run it, otherwise return valid
         */
        _this.validate = function (name, value) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var fields, formResult, validator, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fields = this.stateEngine.select(function (s) { return s.fields; });
                        if (!(this.props.validators && this.props.validators.form)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.props.validators.form("", fields)];
                    case 1:
                        formResult = _a.sent();
                        if (!isCovalidateResult(formResult)) return [3 /*break*/, 3];
                        return [4 /*yield*/, formResult.covalidate.map(function (field) {
                                return _this.validate(field, fields[field].value);
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, this.stateEngine.set({
                            meta: {
                                validation: formResult
                            }
                        })];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        if (!this.props.validators) {
                            return [2 /*return*/, validFn()];
                        }
                        validator = this.props.validators[name];
                        if (!validator) {
                            return [2 /*return*/, validFn()];
                        }
                        return [4 /*yield*/, validator(value, fields)];
                    case 6:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        }); };
        /**
         * Called by Fields when their value changes
         * If a form onChange handler was passed as a prop, call it
         */
        _this.handleFieldChange = function (fieldName, value) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.stateEngine.set(function (_a) {
                            var fields = _a.fields;
                            return ({
                                fields: __assign({}, fields, (_b = {}, _b[fieldName] = __assign({}, fields[fieldName], { value: value, meta: __assign({}, (fields[fieldName] || {}).meta, { isValidating: true }) }), _b))
                            });
                            var _b;
                        })];
                    case 1:
                        _a.sent();
                        this.validate(fieldName, value).then(function (validation) {
                            if (isCovalidateResult(validation)) {
                                Promise.all(validation.covalidate.map(function (covalidatedField) { return __awaiter(_this, void 0, void 0, function () {
                                    var _a;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                _a = {
                                                    covalidatedField: covalidatedField
                                                };
                                                return [4 /*yield*/, this.validate(covalidatedField, this.stateEngine.select(function (s) { return s.fields[covalidatedField].value; }))];
                                            case 1: return [2 /*return*/, (_a.result = _b.sent(),
                                                    _a)];
                                        }
                                    });
                                }); })).then(function (covalidateResults) {
                                    _this.stateEngine.set(function (_a) {
                                        var fields = _a.fields;
                                        return ({
                                            fields: __assign({}, fields, covalidateResults.reduce(function (out, _a) {
                                                var covalidatedField = _a.covalidatedField, result = _a.result;
                                                return (__assign({}, out, (_b = {}, _b[covalidatedField] = __assign({}, fields[covalidatedField], { meta: __assign({}, (fields[covalidatedField] || {})
                                                        .meta, { validation: result, isValidating: false }) }), _b)));
                                                var _b;
                                            }, {}), (_b = {}, _b[fieldName] = __assign({}, fields[fieldName], { meta: __assign({}, (fields[fieldName] || {}).meta, { validation: validation.result, isValidating: false }) }), _b))
                                        });
                                        var _b;
                                    });
                                });
                            }
                            else {
                                _this.stateEngine.set(function (_a) {
                                    var fields = _a.fields;
                                    return ({
                                        fields: __assign({}, fields, (_b = {}, _b[fieldName] = __assign({}, fields[fieldName], { meta: __assign({}, (fields[fieldName] || {}).meta, { validation: validation, isValidating: false }) }), _b))
                                    });
                                    var _b;
                                });
                            }
                        });
                        this.props.onChange(this.stateEngine.select(function (s) { return s.fields; }));
                        return [2 /*return*/];
                }
            });
        }); };
        /**
         * On submit call either props.onSubmit or props.onFailedSubmit
         * depending on current validation status
         */
        _this.handleSubmit = function (onSubmit, onFailedSubmit, valid, fields) { return function (e) {
            e && e.preventDefault();
            _this.stateEngine.set({ submitted: true });
            valid
                ? onSubmit(fields)
                : onFailedSubmit(fields);
        }; };
        _this.stateEngine =
            props.stateEngine ||
                componentStateEngine(_this, {
                    fields: {},
                    submitted: false,
                    meta: {
                        validation: {
                            valid: true
                        }
                    }
                });
        _this.makeField();
        return _this;
    }
    Form.prototype.componentWillReceiveProps = function (nextProps) {
        if (nextProps.validators !== this.props.validators) {
            this.makeField(false);
        }
        return true;
    };
    Form.prototype.render = function () {
        var _a = this.props, render = _a.render, onSubmit = _a.onSubmit, onSubmitFailed = _a.onSubmitFailed, name = _a.name, renderProps = _a.renderProps;
        var _b = this.stateEngine.get(), submitted = _b.submitted, fields = _b.fields, validation = _b.meta.validation;
        var valid = this.allValid(fields);
        /**
         * Filters out all keys from validationResult where valid is true,
         * if form is valid then we know this will be an empty object, so we can
         * just return that
         */
        var validationResult = valid
            ? {}
            : Object.entries(fields).reduce(function (out, _a) {
                var key = _a[0], value = _a[1];
                return Object.assign({}, out, isInvalidResult(value.meta.validation)
                    ? (_b = {},
                        _b[key] = value.meta.validation,
                        _b) : {});
                var _b;
            }, isInvalidResult(validation) ? { form: validation } : {});
        var isValidating = Object.values(fields).some(function (field) { return field.meta.isValidating; });
        var submit = this.handleSubmit(onSubmit, onSubmitFailed, valid, fields);
        return render({
            ownProps: renderProps,
            meta: {
                valid: valid,
                submitted: submitted,
                errors: validationResult,
                isValidating: isValidating
            },
            Field: this.Field,
            values: fields,
            actions: {
                reset: this.reset,
                submit: submit
            },
            form: {
                name: name,
                onSubmit: submit
            }
        });
    };
    Form.defaultProps = {
        initialValues: {},
        onSubmit: function () { },
        onSubmitFailed: function () { },
        onChange: function () { },
        renderProps: {}
    };
    return Form;
}(React.Component));
export { Form };
//# sourceMappingURL=Form.js.map