/**
 * Provides an implementation of StateEngine<FormState> using a
 * components internal state
 */
export var componentStateEngine = function (componentInstance, initialState) {
    componentInstance.state = initialState;
    return {
        select: function (selector) { return selector(componentInstance.state); },
        set: function (update) {
            return new Promise(function (r) { return componentInstance.setState(update, r); });
        },
        get: function () { return componentInstance.state; }
    };
};
//# sourceMappingURL=stateEngine.js.map