import { NotUndefinedMessage } from "./required";
import { Message, CreateValidator, FieldResult } from "./typesAndGuards";
export interface AtLeastMessages<T = string, U = string> extends NotUndefinedMessage<T, U> {
    short?: Message<T, AtLeastParams, U>;
}
export interface AtLeastParams {
    chars: number;
}
/**
 * Validates that a value is at least {chars} long Formatter<T, MessageParams<AtLeastParams>>
 * T is type of formatter result
 * U is type of validation result
 * @param chars Minimum number of characters
 * @param msg Error messages when invalid
 */
export declare const atLeast: <T, U>(params: AtLeastParams, msg?: AtLeastMessages<T, U> | undefined) => CreateValidator<FieldResult, U, T, AtLeastParams>;
