var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import { useFormatter } from "./formatter";
/**
 * Validates that a value is at least {chars} long Formatter<T, MessageParams<AtLeastParams>>
 * T is type of formatter result
 * U is type of validation result
 * @param chars Minimum number of characters
 * @param msg Error messages when invalid
 */
export var atLeast = function (params, msg) { return function (_a, options) {
    var valid = _a.valid, invalid = _a.invalid;
    return function (value) {
        var format = useFormatter(msg, __assign({}, params, { value: value }), options);
        if (!value) {
            return invalid(format("undef", "Please enter a value"));
        }
        return value.toString().length >= params.chars
            ? valid()
            : invalid(format("short", "Entry must be at least " + params.chars + " characters long"));
    };
}; };
//# sourceMappingURL=atLeast.js.map