import { Message, FieldResult, CreateValidator } from "./typesAndGuards";
export interface AtMostMessages<T = string, U = string> {
    long: Message<T, AtMostParams, U>;
}
export interface AtMostParams {
    chars: number;
}
/**
 * Validates that a value is at most {chars} long
 * T is type of formatter result
 * U is type of validation result
 * @param chars Maximum number of characters
 * @param msg Error messages when invalid
 */
export declare const atMost: <T, U>(params: AtMostParams, msg?: AtMostMessages<T, U> | undefined) => CreateValidator<FieldResult, U, T, AtMostParams>;
