import { Message, FieldResult, CreateValidator } from "./typesAndGuards";
import { FieldValue } from "../Form";
export interface ExactlyMessages<T = string, U = string, V = FieldValue> {
    different?: Message<T, ExactlyParams<V>, U>;
}
export interface ExactlyParams<T> {
    value: T;
}
/**
 * Validates that a value is exactly a provided value
 * @param params Value to match
 * @param msg Error messages when invalid
 */
export declare const exactly: <T, U>(params: ExactlyParams<U>, msg?: ExactlyMessages<T, string, U> | undefined) => CreateValidator<FieldResult, U, T, ExactlyParams<U>>;
