/**
 * Encapsulation of logic around null checking messages and
 * apply custom formatter if provided
 * T value type
 * U formatter input type
 * V params type
 * W message name
 */
export var useFormatter = function (msg, args, options) { return function (messageName, defaultMsg) {
    var message = msg && msg[messageName]
        ? typeof msg[messageName] === "function"
            ? msg[messageName](args)
            : msg[messageName]
        : defaultMsg;
    return options && options.formatter
        ? options.formatter(message, args)
        : message;
}; };
//# sourceMappingURL=formatter.js.map