import { useFormatter } from "./formatter";
/**
 * Validates that a value is only numbers
 * @param msg Error messages when invalid
 */
export var numeric = function (msg) { return function (_a, options) {
    var valid = _a.valid, invalid = _a.invalid;
    return function (value) {
        if (typeof value === "undefined") {
            return valid();
        }
        var format = useFormatter(msg, { value: value }, options);
        return /^[0-9]*$/.test(value ? value.toString() : "")
            ? valid()
            : invalid(format("nonNumeric", "Entered value must be a number"));
    };
}; };
//# sourceMappingURL=numeric.js.map