import { Message, FieldResult, CreateValidator } from "./typesAndGuards";
export interface NotUndefinedMessage<T = string, U = string> {
    undef?: Message<T, void, U>;
}
/**
 * Validates that a value is not undefined or zero-length
 * @param msg Error messages when invalid
 */
export declare const required: <T, U>(msg?: NotUndefinedMessage<T, string> | undefined) => CreateValidator<FieldResult, U, T, {
    value: U;
}>;
